(define-module (ui ddos ajax)
    :use-module (alterator ajax)
    :use-module (alterator woo)
    :export (init))

(define (get-state)
  (catch/message
    (lambda()
      (form-update-value-list '("state") (woo-call "/ddos/get_state")))))

(define (get-values)
  (form-update-value-list '("NO_OF_CONNECTIONS" "BAN_PERIOD" "EMAIL_TO") (woo-call "/ddos/get_values")))

(define (on-apply-state)
  (let ((state (form-value "state")))
    (woo-call "/ddos/set_state" 'state state)
    (get-state)))

(define (on-apply)
  (catch/message
    (lambda()
      (woo-call "/ddos/set_values" 'NO_OF_CONNECTIONS (form-value "NO_OF_CONNECTIONS")
                'BAN_PERIOD (form-value "BAN_PERIOD")
                'EMAIL_TO (form-value "EMAIL_TO"))))
  (get-values))

(define (read-wl)
  (catch/message
    (lambda()
      (form-update-enum "whitelist"
                        (woo-list "/ddos/read_whitelist")))))

(define (wl-add-ip)
  (catch/message
    (lambda()
      (woo-call "/ddos/add_whitelist_ip" 'ip_addr (form-value "add_ip"))))
  (form-update-value "add_ip" "")
  (read-wl))

(define (wl-del-ip)
  (catch/message
    (lambda()
      (woo-call "/ddos/del_whitelist_ip" 'ip_addr (form-value "whitelist"))))
  (read-wl))

(define (ui-init)
  (get-state)
  (read-wl)
  (get-values))

(define (init)
  (ui-init)
  (form-bind "wl_add_ip" "click" wl-add-ip)
  (form-bind "wl_del_ip" "click" wl-del-ip)
  (form-bind "apply_state_btn" "click" on-apply-state)
  (form-bind "apply_btn" "click" on-apply))
